"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const reducer_util_1 = require("./reducer.util");
var ActionHandlersUtil;
(function (ActionHandlersUtil) {
    ActionHandlersUtil.reduceXActionHandlers = (xActionHandlers, withSelector) => {
        return Object.keys(xActionHandlers).reduce((result, key) => {
            const value = xActionHandlers[key];
            if (typeof value === "function") {
                result[key] = value;
            }
            else {
                ActionHandlersUtil.mergeActionHandlers(result, withSelector(key), value);
            }
            return result;
        }, {});
    };
    ActionHandlersUtil.mergeActionHandlers = (target, selector, source) => {
        return Object.keys(source).reduce((result, key) => {
            const value = source[key];
            if (typeof value === "function") {
                result[key] = reducer_util_1.ReducerUtil.mapReducer(selector, value);
            }
            else {
                ActionHandlersUtil.mergeActionHandlers(result, selector.select(key), value);
            }
            return result;
        }, target);
    };
})(ActionHandlersUtil = exports.ActionHandlersUtil || (exports.ActionHandlersUtil = {}));
//# sourceMappingURL=action.handlers.util.js.map